Index: kernel/generic/src/console/chardev.c
===================================================================
--- kernel/generic/src/console/chardev.c	(revision 2cc569a32f7a224374397a5bf949d29b469490ca)
+++ kernel/generic/src/console/chardev.c	(revision 40043e8d61ecdedef8f915d74b90ad59d8d19f85)
@@ -39,5 +39,5 @@
 #include <synch/spinlock.h>
 #include <stdio.h>
-#include <halt.h>
+#include <shutdown.h>
 #include <cpu.h>
 
Index: kernel/generic/src/console/cmd.c
===================================================================
--- kernel/generic/src/console/cmd.c	(revision 2cc569a32f7a224374397a5bf949d29b469490ca)
+++ kernel/generic/src/console/cmd.c	(revision 40043e8d61ecdedef8f915d74b90ad59d8d19f85)
@@ -52,5 +52,4 @@
 #include <arch.h>
 #include <config.h>
-#include <halt.h>
 #include <str.h>
 #include <macros.h>
Index: kernel/generic/src/debug/panic.c
===================================================================
--- kernel/generic/src/debug/panic.c	(revision 2cc569a32f7a224374397a5bf949d29b469490ca)
+++ kernel/generic/src/debug/panic.c	(revision 40043e8d61ecdedef8f915d74b90ad59d8d19f85)
@@ -36,5 +36,5 @@
 #include <stdio.h>
 #include <stacktrace.h>
-#include <halt.h>
+#include <shutdown.h>
 #include <typedefs.h>
 #include <mm/as.h>
Index: kernel/generic/src/lib/halt.c
===================================================================
--- kernel/generic/src/lib/halt.c	(revision 2cc569a32f7a224374397a5bf949d29b469490ca)
+++ 	(revision )
@@ -1,82 +1,0 @@
-/*
- * Copyright (c) 2001-2004 Jakub Jermar
- * All rights reserved.
- *
- * Redistribution and use in source and binary forms, with or without
- * modification, are permitted provided that the following conditions
- * are met:
- *
- * - Redistributions of source code must retain the above copyright
- *   notice, this list of conditions and the following disclaimer.
- * - Redistributions in binary form must reproduce the above copyright
- *   notice, this list of conditions and the following disclaimer in the
- *   documentation and/or other materials provided with the distribution.
- * - The name of the author may not be used to endorse or promote products
- *   derived from this software without specific prior written permission.
- *
- * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
- * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
- * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
- * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
- * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
- * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
- * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
- * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
- * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
- * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
- */
-
-/** @addtogroup kernel_generic
- * @{
- */
-
-/**
- * @file
- * @brief Halt function.
- */
-
-#include <halt.h>
-#include <log.h>
-#include <cpu.h>
-#include <arch/asm.h>
-#include <arch.h>
-#include <console/kconsole.h>
-
-/** Halt flag */
-atomic_t haltstate = 0;
-
-/** Halt wrapper
- *
- * Set halt flag and halt the CPU.
- *
- */
-void halt(void)
-{
-#if (defined(CONFIG_DEBUG)) && (defined(CONFIG_KCONSOLE))
-	bool rundebugger = false;
-
-	if (!atomic_load(&haltstate)) {
-		atomic_store(&haltstate, 1);
-		rundebugger = true;
-	}
-#else
-	atomic_store(&haltstate, 1);
-#endif
-
-	interrupts_disable();
-
-#if (defined(CONFIG_DEBUG)) && (defined(CONFIG_KCONSOLE))
-	if ((rundebugger) && (kconsole_check_poll()))
-		kconsole("panic", "\nLast resort kernel console ready.\n", false);
-#endif
-
-	if (CPU)
-		log(LF_OTHER, LVL_NOTE, "cpu%u: halted", CPU->id);
-	else
-		log(LF_OTHER, LVL_NOTE, "cpu: halted");
-
-	cpu_halt();
-}
-
-/** @}
- */
Index: kernel/generic/src/main/shutdown.c
===================================================================
--- kernel/generic/src/main/shutdown.c	(revision 2cc569a32f7a224374397a5bf949d29b469490ca)
+++ kernel/generic/src/main/shutdown.c	(revision 40043e8d61ecdedef8f915d74b90ad59d8d19f85)
@@ -1,4 +1,5 @@
 /*
  * Copyright (c) 2007 Martin Decky
+ * Copyright (c) 2001-2004 Jakub Jermar
  * All rights reserved.
  *
@@ -36,8 +37,47 @@
  */
 
+#include <shutdown.h>
+#include <log.h>
+#include <cpu.h>
+#include <arch/asm.h>
 #include <arch.h>
+#include <console/kconsole.h>
 #include <proc/task.h>
-#include <halt.h>
-#include <log.h>
+
+/** Halt flag */
+atomic_t haltstate = 0;
+
+/** Halt wrapper
+ *
+ * Set halt flag and halt the CPU.
+ *
+ */
+void halt(void)
+{
+#if (defined(CONFIG_DEBUG)) && (defined(CONFIG_KCONSOLE))
+	bool rundebugger = false;
+
+	if (!atomic_load(&haltstate)) {
+		atomic_store(&haltstate, 1);
+		rundebugger = true;
+	}
+#else
+	atomic_store(&haltstate, 1);
+#endif
+
+	interrupts_disable();
+
+#if (defined(CONFIG_DEBUG)) && (defined(CONFIG_KCONSOLE))
+	if ((rundebugger) && (kconsole_check_poll()))
+		kconsole("panic", "\nLast resort kernel console ready.\n", false);
+#endif
+
+	if (CPU)
+		log(LF_OTHER, LVL_NOTE, "cpu%u: halted", CPU->id);
+	else
+		log(LF_OTHER, LVL_NOTE, "cpu: halted");
+
+	cpu_halt();
+}
 
 void reboot(void)
Index: kernel/generic/src/proc/scheduler.c
===================================================================
--- kernel/generic/src/proc/scheduler.c	(revision 2cc569a32f7a224374397a5bf949d29b469490ca)
+++ kernel/generic/src/proc/scheduler.c	(revision 40043e8d61ecdedef8f915d74b90ad59d8d19f85)
@@ -57,5 +57,5 @@
 #include <context.h>
 #include <fpu_context.h>
-#include <halt.h>
+#include <shutdown.h>
 #include <arch.h>
 #include <adt/list.h>